package com.share;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.CoreProtocolPNames;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.protocol.HttpContext;

import android.util.Log;

public class TwitterApi {
	DefaultHttpClient httpClient = null;
	HttpContext localContext = null;
    
    protected final static String TAG = "TWITTER_API";
    
    protected String username;
    protected String password;
    
    public TwitterApi(){
    	httpClient = new DefaultHttpClient();
    	localContext = new BasicHttpContext();
    }
    
    public void setConnectionParams(String username, String password){
    	this.username = username;
    	this.password = password;
    	httpClient.getCredentialsProvider().setCredentials(
    	        new AuthScope("twitter.com", 80),
    	        new UsernamePasswordCredentials(username, password));
    	httpClient.setParams(new BasicHttpParams().setBooleanParameter(CoreProtocolPNames.USE_EXPECT_CONTINUE, false));
    	Log.d(TAG, "new credential for connection to twitter set: "+username+":"+password);
    }
    
    class Pair implements NameValuePair{
		protected String name;
		protected String value;
		@Override
		public String getName() {
			return name;
		}
		@Override
		public String getValue() {
			return value;
		}
		public Pair(String name, String value){
			this.name = name;
			this.value = value;
		}
    }
    
    public boolean postStatusUpdate(String newStatus){
    	String url = "http://twitter.com/statuses/update.json";
    	Log.d(TAG, "Posting twitter status update to "+url);
    	boolean statusUpdated = true;
    	HttpPost httpPost = new HttpPost(url);
		try {
			ArrayList<Pair> parameters = new ArrayList<Pair>();
			parameters.add(new Pair("status", newStatus));
			UrlEncodedFormEntity ent = new UrlEncodedFormEntity(parameters);
	    	httpPost.setEntity(ent);
	    	
	    	HttpResponse response = httpClient.execute(httpPost, localContext);
			Log.d(TAG, "Twitter response: " + response.getStatusLine());
		} catch (UnsupportedEncodingException e1) {	e1.printStackTrace(); 
			statusUpdated = false;
		}
		catch (ClientProtocolException e) { e.printStackTrace();
			statusUpdated = false;}
		catch (IOException e) {e.printStackTrace(); statusUpdated = false;}
    	return statusUpdated;
    }
}
